/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.fastjson.JSON
 *  com.deepexi.open.api.sdk.domain.CarbonFootprintReportVO
 *  com.deepexi.scd.calculate.domain.dto.FootprintReportUploadReq
 *  com.deepexi.scd.calculate.enums.ReportSourceTypeEnum
 *  com.deepexi.scd.calculate.service.CarbonFootprintReportService
 *  org.apache.rocketmq.common.message.MessageExt
 *  org.apache.rocketmq.spring.annotation.RocketMQMessageListener
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.beans.factory.annotation.Value
 *  org.springframework.boot.autoconfigure.condition.ConditionalOnProperty
 *  org.springframework.stereotype.Component
 */
package com.deepexi.scd.calculate.mq.consumer;

import com.alibaba.fastjson.JSON;
import com.deepexi.open.api.sdk.domain.CarbonFootprintReportVO;
import com.deepexi.scd.calculate.domain.dto.FootprintReportUploadReq;
import com.deepexi.scd.calculate.enums.ReportSourceTypeEnum;
import com.deepexi.scd.calculate.mq.consumer.AbstractConsumer;
import com.deepexi.scd.calculate.service.CarbonFootprintReportService;
import java.nio.charset.StandardCharsets;
import java.util.Objects;
import org.apache.rocketmq.common.message.MessageExt;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Component;

@Component
@RocketMQMessageListener(nameServer="${deepexi.scd.rocketmq.name-server}", topic="${deepexi.scd.rocketmq.topic.report}", consumerGroup="${deepexi.scd.rocketmq.consumer.report.group}")
@ConditionalOnProperty(prefix="deepexi.scd.rocketmq", value={"enable"}, havingValue="true", matchIfMissing=true)
public class GeneratorReportConsumer
extends AbstractConsumer {
    private static final Logger log = LoggerFactory.getLogger(GeneratorReportConsumer.class);
    @Value(value="${deepexi.scd.rocketmq.topic.report}")
    private String topic;
    @Autowired
    private CarbonFootprintReportService carbonFootprintReportService;

    @Override
    protected void readMessage(MessageExt message) {
        String body = new String(message.getBody(), StandardCharsets.UTF_8);
        log.info("报告生成的消费数据为：{}", (Object)body);
        CarbonFootprintReportVO vo = (CarbonFootprintReportVO)JSON.parseObject((String)body, CarbonFootprintReportVO.class);
        if (Objects.nonNull(vo)) {
            FootprintReportUploadReq reportReq = new FootprintReportUploadReq();
            reportReq.setFootprintId(vo.getFootprintId());
            reportReq.setEnterpriseId(vo.getEnterpriseId());
            reportReq.setSourceType(ReportSourceTypeEnum.SYSTEM);
            reportReq.setGenerated(Integer.valueOf(0));
            reportReq.setPdfUrl(vo.getDetailReportPdfUrl());
            reportReq.setFileUrl(vo.getDetailReportUrl());
            reportReq.setAverageEmission(vo.getAverageEmission());
            reportReq.setSimplePdfUrl(vo.getSimpleReportPdfUrl());
            reportReq.setSimpleDocUrl(vo.getSimpleReportDocUrl());
            reportReq.setGenerated(Integer.valueOf(1));
            reportReq.setSourceType(ReportSourceTypeEnum.SYSTEM);
            reportReq.setReportId(vo.getReportId());
            this.carbonFootprintReportService.updateGeneratedStatus(reportReq);
        }
    }

    @Override
    protected String getTopic() {
        return this.topic;
    }
}

